"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.validate = exports.entries = exports.map = exports.get = exports.pointer = exports.value = exports.nil = undefined;

var _bluebird = require("bluebird");

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _jsonStableStringify = require("json-stable-stringify");

var _jsonStableStringify2 = _interopRequireDefault(_jsonStableStringify);

var _textEncoding = require("text-encoding");

var _jsonPointer = require("@hyperjump/json-pointer");

var JsonPointer = _interopRequireWildcard(_jsonPointer);

var _jsonReference = require("@hyperjump/json-reference");

var JsonReference = _interopRequireWildcard(_jsonReference);

var _validationResult = require("./validation-result");

var ValidationResult = _interopRequireWildcard(_validationResult);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var nil = exports.nil = JsonReference.nil;
var value = exports.value = JsonReference.value;
var pointer = exports.pointer = JsonReference.pointer;
var get = exports.get = JsonReference.get;
var map = exports.map = JsonReference.map;
var entries = exports.entries = JsonReference.entries;

var validate = exports.validate = function () {
  var _ref = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee(doc) {
    var meta, result, memo;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return _metaCompile(doc);

          case 2:
            meta = _context.sent;
            result = _metaInterpret(meta, value(doc));

            if (ValidationResult.isValid(result)) {
              _context.next = 6;
              break;
            }

            throw result;

          case 6:
            _context.next = 8;
            return _compile(doc, {});

          case 8:
            memo = _context.sent;
            return _context.abrupt("return", _interpret(memo, doc.url));

          case 10:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function validate(_x) {
    return _ref.apply(this, arguments);
  };
}();

var _compile = function () {
  var _ref2 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(doc, memo) {
    var $meta, meta;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            if (!(memo[doc.url] === undefined)) {
              _context3.next = 9;
              break;
            }

            memo[doc.url] = false;

            _context3.next = 4;
            return get("#/$meta", doc);

          case 4:
            $meta = _context3.sent;
            meta = value($meta) || {};
            _context3.next = 8;
            return entries(doc).filter(function (_ref3) {
              var _ref4 = _slicedToArray(_ref3, 2),
                  keyword = _ref4[0],
                  _ = _ref4[1];

              return keyword !== "$meta";
            }).map(function () {
              var _ref5 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref6) {
                var _ref7 = _slicedToArray(_ref6, 2),
                    keyword = _ref7[0],
                    keywordDoc = _ref7[1];

                var keywordUrl, node;
                return regeneratorRuntime.wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        if (keyword in meta) {
                          _context2.next = 2;
                          break;
                        }

                        throw Error("Encountered undeclared keyword '" + keyword + "' at '" + keywordDoc.url + "'");

                      case 2:
                        keywordUrl = meta[keyword];
                        _context2.next = 5;
                        return keywords[keywordUrl].compile(keywordDoc, memo);

                      case 5:
                        node = _context2.sent;
                        return _context2.abrupt("return", [keywordUrl, keywordDoc.url, node]);

                      case 7:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2, undefined);
              }));

              return function (_x4) {
                return _ref5.apply(this, arguments);
              };
            }());

          case 8:
            memo[doc.url] = _context3.sent;

          case 9:
            return _context3.abrupt("return", memo);

          case 10:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, undefined);
  }));

  return function _compile(_x2, _x3) {
    return _ref2.apply(this, arguments);
  };
}();

var metaMemo = {};
var _metaCompile = function () {
  var _ref8 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(doc) {
    var $meta, meta;
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return get("#/$meta", doc);

          case 2:
            $meta = _context5.sent;
            meta = value($meta) || {};
            _context5.next = 6;
            return Promise.all(Object.entries(meta).filter(function (_ref9) {
              var _ref10 = _slicedToArray(_ref9, 2),
                  keyword = _ref10[0],
                  keywordUrl = _ref10[1];

              return keyword[0] !== "$" && !(keywordUrl in metaMemo);
            }).map(function () {
              var _ref11 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(_ref12) {
                var _ref13 = _slicedToArray(_ref12, 2),
                    keyword = _ref13[0],
                    _ = _ref13[1];

                var keywordUrl, metaDoc;
                return regeneratorRuntime.wrap(function _callee4$(_context4) {
                  while (1) {
                    switch (_context4.prev = _context4.next) {
                      case 0:
                        keywordUrl = meta[keyword];
                        //console.log(keywordUrl, keywords[keywordUrl]);

                        metaDoc = { url: keywordUrl, content: keywords[keywordUrl].validation };
                        _context4.next = 4;
                        return _compile(metaDoc, metaMemo);

                      case 4:
                        return _context4.abrupt("return", _context4.sent);

                      case 5:
                      case "end":
                        return _context4.stop();
                    }
                  }
                }, _callee4, undefined);
              }));

              return function (_x6) {
                return _ref11.apply(this, arguments);
              };
            }()));

          case 6:
            return _context5.abrupt("return", meta);

          case 7:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5, undefined);
  }));

  return function _metaCompile(_x5) {
    return _ref8.apply(this, arguments);
  };
}();

var _interpret = function _interpret(memo, url) {
  return function (value) {
    return memo[url].map(function (_ref14) {
      var _ref15 = _slicedToArray(_ref14, 3),
          keywordUrl = _ref15[0],
          ptr = _ref15[1],
          keywordValue = _ref15[2];

      return [ptr, keywords[keywordUrl].interpret(keywordValue, value, memo)];
    });
  };
};

var _metaInterpret = function _metaInterpret(meta, value) {
  return Object.keys(value).filter(function (keyword) {
    return keyword in meta;
  }).map(function (keyword) {
    var keywordUrl = meta[keyword];
    var result = _interpret(metaMemo, keywordUrl)(value[keyword]);
    return [JsonPointer.cons(JsonPointer.nil, keyword), ValidationResult.isValid(result)];
  });
};

var isObject = function isObject(value) {
  return (typeof value === "undefined" ? "undefined" : _typeof(value)) === "object" && !Array.isArray(value) && value !== null;
};

var isType = {
  "null": function _null(value) {
    return value === null;
  },
  "boolean": function boolean(value) {
    return typeof value === "boolean";
  },
  "object": isObject,
  "array": function array(value) {
    return Array.isArray(value);
  },
  "number": function number(value) {
    return typeof value === "number";
  },
  "string": function string(value) {
    return typeof value === "string";
  }
};

var numberEqual = function numberEqual(a, b) {
  return Math.abs(a - b) < Number.EPSILON;
};

var multipleOf = function multipleOf(_multipleOf, value) {
  var remainder = value % _multipleOf;
  return numberEqual(0, remainder) || numberEqual(_multipleOf, remainder);
};

var jsonStringLength = function jsonStringLength(string) {
  return new _textEncoding.TextEncoder("utf-8").encode(string).length;
};

var keywords = {};

keywords["http://validation.hyperjump.io/common/const"] = {
  validation: {},
  compile: function () {
    var _ref16 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(doc) {
      return regeneratorRuntime.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              return _context6.abrupt("return", (0, _jsonStableStringify2.default)(value(doc)));

            case 1:
            case "end":
              return _context6.stop();
          }
        }
      }, _callee6, undefined);
    }));

    return function compile(_x7) {
      return _ref16.apply(this, arguments);
    };
  }(),
  interpret: function interpret(constValue, value) {
    return (0, _jsonStableStringify2.default)(value) === constValue;
  }
};

keywords["http://validation.hyperjump.io/common/type"] = {
  validation: {
    "$meta": { "$ref": "http://validation.hyperjump.io/common" },
    "anyOf": [{ "const": "null" }, { "const": "boolean" }, { "const": "object" }, { "const": "array" }, { "const": "number" }, { "const": "string" }]
  },
  compile: function () {
    var _ref17 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(doc) {
      return regeneratorRuntime.wrap(function _callee7$(_context7) {
        while (1) {
          switch (_context7.prev = _context7.next) {
            case 0:
              return _context7.abrupt("return", value(doc));

            case 1:
            case "end":
              return _context7.stop();
          }
        }
      }, _callee7, undefined);
    }));

    return function compile(_x8) {
      return _ref17.apply(this, arguments);
    };
  }(),
  interpret: function interpret(type, value) {
    return isType[type](value);
  }
};

keywords["http://validation.hyperjump.io/common/multipleOf"] = {
  validation: {
    "$meta": { "$ref": "http://validation.hyperjump.io/common" },
    "type": "number"
  },
  compile: function () {
    var _ref18 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(doc) {
      return regeneratorRuntime.wrap(function _callee8$(_context8) {
        while (1) {
          switch (_context8.prev = _context8.next) {
            case 0:
              return _context8.abrupt("return", value(doc));

            case 1:
            case "end":
              return _context8.stop();
          }
        }
      }, _callee8, undefined);
    }));

    return function compile(_x9) {
      return _ref18.apply(this, arguments);
    };
  }(),
  interpret: function interpret(multipleOfValue, value) {
    return typeof value !== "number" || multipleOf(multipleOfValue, value);
  }
};

keywords["http://validation.hyperjump.io/common/maximum"] = {
  validation: {
    "$meta": { "$ref": "http://validation.hyperjump.io/common" },
    "type": "number"
  },
  compile: function () {
    var _ref19 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee9(doc) {
      return regeneratorRuntime.wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              return _context9.abrupt("return", value(doc));

            case 1:
            case "end":
              return _context9.stop();
          }
        }
      }, _callee9, undefined);
    }));

    return function compile(_x10) {
      return _ref19.apply(this, arguments);
    };
  }(),
  interpret: function interpret(maximum, value) {
    return typeof value !== "number" || value <= maximum;
  }
};

keywords["http://validation.hyperjump.io/common/exclusiveMaximum"] = {
  validation: {
    "$meta": { "$ref": "http://validation.hyperjump.io/common" },
    "type": "number"
  },
  compile: function () {
    var _ref20 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee10(doc) {
      return regeneratorRuntime.wrap(function _callee10$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              return _context10.abrupt("return", value(doc));

            case 1:
            case "end":
              return _context10.stop();
          }
        }
      }, _callee10, undefined);
    }));

    return function compile(_x11) {
      return _ref20.apply(this, arguments);
    };
  }(),
  interpret: function interpret(exclusiveMaximum, value) {
    return typeof value !== "number" || value < exclusiveMaximum;
  }
};

keywords["http://validation.hyperjump.io/common/minimum"] = {
  validation: {
    "$meta": { "$ref": "http://validation.hyperjump.io/common" },
    "type": "number"
  },
  compile: function () {
    var _ref21 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee11(doc) {
      return regeneratorRuntime.wrap(function _callee11$(_context11) {
        while (1) {
          switch (_context11.prev = _context11.next) {
            case 0:
              return _context11.abrupt("return", value(doc));

            case 1:
            case "end":
              return _context11.stop();
          }
        }
      }, _callee11, undefined);
    }));

    return function compile(_x12) {
      return _ref21.apply(this, arguments);
    };
  }(),
  interpret: function interpret(minimum, value) {
    return typeof value !== "number" || value >= minimum;
  }
};

keywords["http://validation.hyperjump.io/common/exclusiveMinimum"] = {
  validation: {
    "$meta": { "$ref": "http://validation.hyperjump.io/common" },
    "type": "number"
  },
  compile: function () {
    var _ref22 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee12(doc) {
      return regeneratorRuntime.wrap(function _callee12$(_context12) {
        while (1) {
          switch (_context12.prev = _context12.next) {
            case 0:
              return _context12.abrupt("return", value(doc));

            case 1:
            case "end":
              return _context12.stop();
          }
        }
      }, _callee12, undefined);
    }));

    return function compile(_x13) {
      return _ref22.apply(this, arguments);
    };
  }(),
  interpret: function interpret(exclusiveMinimum, value) {
    return typeof value !== "number" || value > exclusiveMinimum;
  }
};

keywords["http://validation.hyperjump.io/common/maxLength"] = {
  validation: {
    "$meta": { "$ref": "http://validation.hyperjump.io/common" },
    "type": "number"
  },
  compile: function () {
    var _ref23 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee13(doc) {
      return regeneratorRuntime.wrap(function _callee13$(_context13) {
        while (1) {
          switch (_context13.prev = _context13.next) {
            case 0:
              return _context13.abrupt("return", value(doc));

            case 1:
            case "end":
              return _context13.stop();
          }
        }
      }, _callee13, undefined);
    }));

    return function compile(_x14) {
      return _ref23.apply(this, arguments);
    };
  }(),
  interpret: function interpret(maxLength, value) {
    return typeof value !== "string" || jsonStringLength(value) <= maxLength;
  }
};

keywords["http://validation.hyperjump.io/common/minLength"] = {
  validation: {
    "$meta": { "$ref": "http://validation.hyperjump.io/common" },
    "type": "number"
  },
  compile: function () {
    var _ref24 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee14(doc) {
      return regeneratorRuntime.wrap(function _callee14$(_context14) {
        while (1) {
          switch (_context14.prev = _context14.next) {
            case 0:
              return _context14.abrupt("return", value(doc));

            case 1:
            case "end":
              return _context14.stop();
          }
        }
      }, _callee14, undefined);
    }));

    return function compile(_x15) {
      return _ref24.apply(this, arguments);
    };
  }(),
  interpret: function interpret(minLength, value) {
    return typeof value !== "string" || jsonStringLength(value) >= minLength;
  }
};

keywords["http://validation.hyperjump.io/common/pattern"] = {
  validation: {
    "$meta": { "$ref": "http://validation.hyperjump.io/common" },
    "type": "string"
  },
  compile: function () {
    var _ref25 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee15(doc) {
      return regeneratorRuntime.wrap(function _callee15$(_context15) {
        while (1) {
          switch (_context15.prev = _context15.next) {
            case 0:
              return _context15.abrupt("return", new RegExp(value(doc)));

            case 1:
            case "end":
              return _context15.stop();
          }
        }
      }, _callee15, undefined);
    }));

    return function compile(_x16) {
      return _ref25.apply(this, arguments);
    };
  }(),
  interpret: function interpret(pattern, value) {
    return typeof value !== "string" || pattern.test(value);
  }
};

keywords["http://validation.hyperjump.io/common/items"] = {
  validation: {
    "$meta": { "$ref": "http://validation.hyperjump.io/common" },
    "type": "object",
    "validation": true
  },
  compile: function () {
    var _ref26 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee16(doc, memo) {
      return regeneratorRuntime.wrap(function _callee16$(_context16) {
        while (1) {
          switch (_context16.prev = _context16.next) {
            case 0:
              _context16.next = 2;
              return _compile(doc, memo);

            case 2:
              return _context16.abrupt("return", doc.url);

            case 3:
            case "end":
              return _context16.stop();
          }
        }
      }, _callee16, undefined);
    }));

    return function compile(_x17, _x18) {
      return _ref26.apply(this, arguments);
    };
  }(),
  interpret: function interpret(items, value, memo) {
    return !Array.isArray(value) || value.every(function (item) {
      var result = _interpret(memo, items)(item);
      return ValidationResult.isValid(result);
    });
  }
};

keywords["http://validation.hyperjump.io/common/tupleItems"] = {
  validation: {
    "$meta": { "$ref": "http://validation.hyperjump.io/common" },
    "type": "array",
    "items": {
      "type": "object",
      "validation": true
    }
  },
  compile: function () {
    var _ref27 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee18(doc, memo) {
      return regeneratorRuntime.wrap(function _callee18$(_context18) {
        while (1) {
          switch (_context18.prev = _context18.next) {
            case 0:
              _context18.next = 2;
              return map(function () {
                var _ref28 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee17(itemDoc) {
                  return regeneratorRuntime.wrap(function _callee17$(_context17) {
                    while (1) {
                      switch (_context17.prev = _context17.next) {
                        case 0:
                          _context17.next = 2;
                          return _compile(itemDoc, memo);

                        case 2:
                          return _context17.abrupt("return", itemDoc.url);

                        case 3:
                        case "end":
                          return _context17.stop();
                      }
                    }
                  }, _callee17, undefined);
                }));

                return function (_x21) {
                  return _ref28.apply(this, arguments);
                };
              }(), doc);

            case 2:
              return _context18.abrupt("return", _context18.sent);

            case 3:
            case "end":
              return _context18.stop();
          }
        }
      }, _callee18, undefined);
    }));

    return function compile(_x19, _x20) {
      return _ref27.apply(this, arguments);
    };
  }(),
  interpret: function interpret(tupleItems, value, memo) {
    return !Array.isArray(value) || value.every(function (item, ndx) {
      if (!(ndx in tupleItems)) {
        return true;
      }

      var result = _interpret(memo, tupleItems[ndx])(item);
      return ValidationResult.isValid(result);
    });
  }
};

keywords["http://validation.hyperjump.io/common/maxItems"] = {
  validation: {
    "$meta": { "$ref": "http://validation.hyperjump.io/common" },
    "type": "number",
    "minimum": 0,
    "multipleOf": 1
  },
  compile: function () {
    var _ref29 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee19(doc) {
      return regeneratorRuntime.wrap(function _callee19$(_context19) {
        while (1) {
          switch (_context19.prev = _context19.next) {
            case 0:
              return _context19.abrupt("return", value(doc));

            case 1:
            case "end":
              return _context19.stop();
          }
        }
      }, _callee19, undefined);
    }));

    return function compile(_x22) {
      return _ref29.apply(this, arguments);
    };
  }(),
  interpret: function interpret(maxItems, value) {
    return !Array.isArray(value) || value.length <= maxItems;
  }
};

keywords["http://validation.hyperjump.io/common/minItems"] = {
  validation: {
    "$meta": { "$ref": "http://validation.hyperjump.io/common" },
    "type": "number",
    "minimum": 0,
    "multipleOf": 1
  },
  compile: function () {
    var _ref30 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee20(doc) {
      return regeneratorRuntime.wrap(function _callee20$(_context20) {
        while (1) {
          switch (_context20.prev = _context20.next) {
            case 0:
              return _context20.abrupt("return", value(doc));

            case 1:
            case "end":
              return _context20.stop();
          }
        }
      }, _callee20, undefined);
    }));

    return function compile(_x23) {
      return _ref30.apply(this, arguments);
    };
  }(),
  interpret: function interpret(minItems, value) {
    return !Array.isArray(value) || value.length >= minItems;
  }
};

keywords["http://validation.hyperjump.io/common/uniqueItems"] = {
  validation: {
    "$meta": { "$ref": "http://validation.hyperjump.io/common" },
    "type": "boolean"
  },
  compile: function () {
    var _ref31 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee21(doc) {
      return regeneratorRuntime.wrap(function _callee21$(_context21) {
        while (1) {
          switch (_context21.prev = _context21.next) {
            case 0:
              return _context21.abrupt("return", value(doc));

            case 1:
            case "end":
              return _context21.stop();
          }
        }
      }, _callee21, undefined);
    }));

    return function compile(_x24) {
      return _ref31.apply(this, arguments);
    };
  }(),
  interpret: function interpret(uniqueItems, value) {
    if (!Array.isArray(value) || uniqueItems === false) {
      return true;
    }

    var normalizedItems = value.map(_jsonStableStringify2.default);
    return new Set(normalizedItems).size === normalizedItems.length;
  }
};

keywords["http://validation.hyperjump.io/common/properties"] = {
  validation: {
    "$meta": { "$ref": "http://validation.hyperjump.io/common" },
    "type": "object",
    "patternProperties": {
      "": {
        "type": "object",
        "validation": true
      }
    }
  },
  compile: function () {
    var _ref32 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee23(doc, memo) {
      return regeneratorRuntime.wrap(function _callee23$(_context23) {
        while (1) {
          switch (_context23.prev = _context23.next) {
            case 0:
              _context23.next = 2;
              return entries(doc).reduce(function () {
                var _ref33 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee22(acc, _ref34) {
                  var _ref35 = _slicedToArray(_ref34, 2),
                      propertyName = _ref35[0],
                      propertyDoc = _ref35[1];

                  return regeneratorRuntime.wrap(function _callee22$(_context22) {
                    while (1) {
                      switch (_context22.prev = _context22.next) {
                        case 0:
                          _context22.next = 2;
                          return _compile(propertyDoc, memo);

                        case 2:
                          acc[propertyName] = propertyDoc.url;
                          return _context22.abrupt("return", acc);

                        case 4:
                        case "end":
                          return _context22.stop();
                      }
                    }
                  }, _callee22, undefined);
                }));

                return function (_x27, _x28) {
                  return _ref33.apply(this, arguments);
                };
              }(), {});

            case 2:
              return _context23.abrupt("return", _context23.sent);

            case 3:
            case "end":
              return _context23.stop();
          }
        }
      }, _callee23, undefined);
    }));

    return function compile(_x25, _x26) {
      return _ref32.apply(this, arguments);
    };
  }(),
  interpret: function interpret(properties, value, memo) {
    return !isObject(value) || Object.keys(value).filter(function (propertyName) {
      return propertyName in properties;
    }).every(function (propertyName) {
      var result = _interpret(memo, properties[propertyName])(value[propertyName]);
      return ValidationResult.isValid(result);
    });
  }
};

keywords["http://validation.hyperjump.io/common/patternProperties"] = {
  validation: {
    "$meta": { "$ref": "http://validation.hyperjump.io/common" },
    "type": "object",
    "patternProperties": {
      "": {
        "type": "object",
        "validation": true
      }
    }
  },
  compile: function () {
    var _ref36 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee25(doc, memo) {
      return regeneratorRuntime.wrap(function _callee25$(_context25) {
        while (1) {
          switch (_context25.prev = _context25.next) {
            case 0:
              _context25.next = 2;
              return entries(doc).map(function () {
                var _ref37 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee24(_ref38) {
                  var _ref39 = _slicedToArray(_ref38, 2),
                      propertyPattern = _ref39[0],
                      propertyDoc = _ref39[1];

                  return regeneratorRuntime.wrap(function _callee24$(_context24) {
                    while (1) {
                      switch (_context24.prev = _context24.next) {
                        case 0:
                          _context24.next = 2;
                          return _compile(propertyDoc, memo);

                        case 2:
                          return _context24.abrupt("return", [new RegExp(propertyPattern), propertyDoc.url]);

                        case 3:
                        case "end":
                          return _context24.stop();
                      }
                    }
                  }, _callee24, undefined);
                }));

                return function (_x31) {
                  return _ref37.apply(this, arguments);
                };
              }());

            case 2:
              return _context25.abrupt("return", _context25.sent);

            case 3:
            case "end":
              return _context25.stop();
          }
        }
      }, _callee25, undefined);
    }));

    return function compile(_x29, _x30) {
      return _ref36.apply(this, arguments);
    };
  }(),
  interpret: function interpret(patternProperties, value, memo) {
    return !isObject(value) || patternProperties.every(function (_ref40) {
      var _ref41 = _slicedToArray(_ref40, 2),
          pattern = _ref41[0],
          property = _ref41[1];

      return Object.keys(value).filter(function (propertyName) {
        return pattern.test(propertyName);
      }).every(function (propertyName) {
        var result = _interpret(memo, property)(value[propertyName]);
        return ValidationResult.isValid(result);
      });
    });
  }
};

keywords["http://validation.hyperjump.io/common/propertyNames"] = {
  validation: {
    "$meta": { "$ref": "http://validation.hyperjump.io/common" },
    "type": "object",
    "validation": true
  },
  compile: function () {
    var _ref42 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee26(doc, memo) {
      return regeneratorRuntime.wrap(function _callee26$(_context26) {
        while (1) {
          switch (_context26.prev = _context26.next) {
            case 0:
              _context26.next = 2;
              return _compile(doc, memo);

            case 2:
              return _context26.abrupt("return", doc.url);

            case 3:
            case "end":
              return _context26.stop();
          }
        }
      }, _callee26, undefined);
    }));

    return function compile(_x32, _x33) {
      return _ref42.apply(this, arguments);
    };
  }(),
  interpret: function interpret(propertyNames, value, memo) {
    return !isObject(value) || Object.keys(value).every(function (name) {
      var result = _interpret(memo, propertyNames)(name);
      return ValidationResult.isValid(result);
    });
  }
};

keywords["http://validation.hyperjump.io/common/maxProperties"] = {
  validation: {
    "$meta": { "$ref": "http://validation.hyperjump.io/common" },
    "type": "number",
    "minimum": 0,
    "multipleOf": 1
  },
  compile: function () {
    var _ref43 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee27(doc) {
      return regeneratorRuntime.wrap(function _callee27$(_context27) {
        while (1) {
          switch (_context27.prev = _context27.next) {
            case 0:
              return _context27.abrupt("return", value(doc));

            case 1:
            case "end":
              return _context27.stop();
          }
        }
      }, _callee27, undefined);
    }));

    return function compile(_x34) {
      return _ref43.apply(this, arguments);
    };
  }(),
  interpret: function interpret(maxProperties, value) {
    return !isObject(value) || Object.keys(value).length <= maxProperties;
  }
};

keywords["http://validation.hyperjump.io/common/minProperties"] = {
  validation: {
    "$meta": { "$ref": "http://validation.hyperjump.io/common" },
    "type": "number",
    "minimum": 0,
    "multipleOf": 1
  },
  compile: function () {
    var _ref44 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee28(doc) {
      return regeneratorRuntime.wrap(function _callee28$(_context28) {
        while (1) {
          switch (_context28.prev = _context28.next) {
            case 0:
              return _context28.abrupt("return", value(doc));

            case 1:
            case "end":
              return _context28.stop();
          }
        }
      }, _callee28, undefined);
    }));

    return function compile(_x35) {
      return _ref44.apply(this, arguments);
    };
  }(),
  interpret: function interpret(minProperties, value) {
    return !isObject(value) || Object.keys(value).length >= minProperties;
  }
};

keywords["http://validation.hyperjump.io/common/required"] = {
  validation: {
    "$meta": { "$ref": "http://validation.hyperjump.io/common" },
    "type": "array",
    "items": {
      "type": "string"
    }
  },
  compile: function () {
    var _ref45 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee29(doc) {
      return regeneratorRuntime.wrap(function _callee29$(_context29) {
        while (1) {
          switch (_context29.prev = _context29.next) {
            case 0:
              return _context29.abrupt("return", value(doc));

            case 1:
            case "end":
              return _context29.stop();
          }
        }
      }, _callee29, undefined);
    }));

    return function compile(_x36) {
      return _ref45.apply(this, arguments);
    };
  }(),
  interpret: function interpret(required, value) {
    return !isObject(value) || required.every(function (propertyName) {
      return propertyName in value;
    });
  }
};

keywords["http://validation.hyperjump.io/common/allOf"] = {
  validation: {
    "$meta": { "$ref": "http://validation.hyperjump.io/common" },
    "type": "array",
    "items": {
      "type": "object",
      "validation": true
    }
  },
  compile: function () {
    var _ref46 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee31(doc, memo) {
      return regeneratorRuntime.wrap(function _callee31$(_context31) {
        while (1) {
          switch (_context31.prev = _context31.next) {
            case 0:
              _context31.next = 2;
              return map(function () {
                var _ref47 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee30(subDoc) {
                  return regeneratorRuntime.wrap(function _callee30$(_context30) {
                    while (1) {
                      switch (_context30.prev = _context30.next) {
                        case 0:
                          _context30.next = 2;
                          return _compile(subDoc, memo);

                        case 2:
                          return _context30.abrupt("return", subDoc.url);

                        case 3:
                        case "end":
                          return _context30.stop();
                      }
                    }
                  }, _callee30, undefined);
                }));

                return function (_x39) {
                  return _ref47.apply(this, arguments);
                };
              }(), doc);

            case 2:
              return _context31.abrupt("return", _context31.sent);

            case 3:
            case "end":
              return _context31.stop();
          }
        }
      }, _callee31, undefined);
    }));

    return function compile(_x37, _x38) {
      return _ref46.apply(this, arguments);
    };
  }(),
  interpret: function interpret(allOf, value, memo) {
    return allOf.every(function (subDoc) {
      var result = _interpret(memo, subDoc)(value);
      return ValidationResult.isValid(result);
    });
  }
};

keywords["http://validation.hyperjump.io/common/anyOf"] = {
  validation: {
    "$meta": { "$ref": "http://validation.hyperjump.io/common" },
    "type": "array",
    "items": {
      "type": "object",
      "validation": true
    }
  },
  compile: function () {
    var _ref48 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee33(doc, memo) {
      return regeneratorRuntime.wrap(function _callee33$(_context33) {
        while (1) {
          switch (_context33.prev = _context33.next) {
            case 0:
              _context33.next = 2;
              return map(function () {
                var _ref49 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee32(subDoc) {
                  return regeneratorRuntime.wrap(function _callee32$(_context32) {
                    while (1) {
                      switch (_context32.prev = _context32.next) {
                        case 0:
                          _context32.next = 2;
                          return _compile(subDoc, memo);

                        case 2:
                          return _context32.abrupt("return", subDoc.url);

                        case 3:
                        case "end":
                          return _context32.stop();
                      }
                    }
                  }, _callee32, undefined);
                }));

                return function (_x42) {
                  return _ref49.apply(this, arguments);
                };
              }(), doc);

            case 2:
              return _context33.abrupt("return", _context33.sent);

            case 3:
            case "end":
              return _context33.stop();
          }
        }
      }, _callee33, undefined);
    }));

    return function compile(_x40, _x41) {
      return _ref48.apply(this, arguments);
    };
  }(),
  interpret: function interpret(anyOf, value, memo) {
    return anyOf.some(function (url) {
      var result = _interpret(memo, url)(value);
      return ValidationResult.isValid(result);
    });
  }
};

keywords["http://validation.hyperjump.io/common/oneOf"] = {
  validation: {
    "$meta": { "$ref": "http://validation.hyperjump.io/common" },
    "type": "array",
    "items": {
      "type": "object",
      "validation": true
    }
  },
  compile: function () {
    var _ref50 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee35(doc, memo) {
      return regeneratorRuntime.wrap(function _callee35$(_context35) {
        while (1) {
          switch (_context35.prev = _context35.next) {
            case 0:
              _context35.next = 2;
              return map(function () {
                var _ref51 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee34(subDoc) {
                  return regeneratorRuntime.wrap(function _callee34$(_context34) {
                    while (1) {
                      switch (_context34.prev = _context34.next) {
                        case 0:
                          _context34.next = 2;
                          return _compile(subDoc, memo);

                        case 2:
                          return _context34.abrupt("return", subDoc.url);

                        case 3:
                        case "end":
                          return _context34.stop();
                      }
                    }
                  }, _callee34, undefined);
                }));

                return function (_x45) {
                  return _ref51.apply(this, arguments);
                };
              }(), doc);

            case 2:
              return _context35.abrupt("return", _context35.sent);

            case 3:
            case "end":
              return _context35.stop();
          }
        }
      }, _callee35, undefined);
    }));

    return function compile(_x43, _x44) {
      return _ref50.apply(this, arguments);
    };
  }(),
  interpret: function interpret(oneOf, value, memo) {
    return oneOf.reduce(function (acc, subDoc) {
      var result = _interpret(memo, subDoc)(value);
      var isValid = ValidationResult.isValid(result);
      return acc ? !isValid : isValid;
    }, false);
  }
};

keywords["http://validation.hyperjump.io/common/not"] = {
  validation: {
    "$meta": { "$ref": "http://validation.hyperjump.io/common" },
    "type": "object",
    "validation": true
  },
  compile: function () {
    var _ref52 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee36(doc, memo) {
      return regeneratorRuntime.wrap(function _callee36$(_context36) {
        while (1) {
          switch (_context36.prev = _context36.next) {
            case 0:
              _context36.next = 2;
              return _compile(doc, memo);

            case 2:
              return _context36.abrupt("return", doc.url);

            case 3:
            case "end":
              return _context36.stop();
          }
        }
      }, _callee36, undefined);
    }));

    return function compile(_x46, _x47) {
      return _ref52.apply(this, arguments);
    };
  }(),
  interpret: function interpret(not, value, memo) {
    var result = _interpret(memo, not)(value);
    return !ValidationResult.isValid(result);
  }
};

keywords["http://validation.hyperjump.io/common/definitions"] = {
  validation: {
    "$meta": { "$ref": "http://validation.hyperjump.io/common" },
    "type": "object",
    "patternProperties": {
      "": {
        "type": "object",
        "validation": true
      }
    }
  },
  compile: function () {
    var _ref53 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee37() {
      return regeneratorRuntime.wrap(function _callee37$(_context37) {
        while (1) {
          switch (_context37.prev = _context37.next) {
            case 0:
              return _context37.abrupt("return", undefined);

            case 1:
            case "end":
              return _context37.stop();
          }
        }
      }, _callee37, undefined);
    }));

    return function compile() {
      return _ref53.apply(this, arguments);
    };
  }(),
  interpret: function interpret() {
    return true;
  }
};

keywords["http://validation.hyperjump.io/common/validation"] = {
  validation: {},
  compile: function () {
    var _ref54 = (0, _bluebird.coroutine)( /*#__PURE__*/regeneratorRuntime.mark(function _callee38(doc) {
      var meta;
      return regeneratorRuntime.wrap(function _callee38$(_context38) {
        while (1) {
          switch (_context38.prev = _context38.next) {
            case 0:
              _context38.next = 2;
              return _metaCompile(doc);

            case 2:
              meta = _context38.sent;
              return _context38.abrupt("return", [value(doc), meta]);

            case 4:
            case "end":
              return _context38.stop();
          }
        }
      }, _callee38, undefined);
    }));

    return function compile(_x48) {
      return _ref54.apply(this, arguments);
    };
  }(),
  interpret: function interpret(_ref55, value) {
    var _ref56 = _slicedToArray(_ref55, 2),
        validation = _ref56[0],
        meta = _ref56[1];

    if (!isObject(value) || !validation) {
      return true;
    }

    var result = _metaInterpret(meta, value);
    return ValidationResult.isValid(result);
  }
};